#This File is a Python 3 Script that run to Read the data from a .csv file
#The before reading the coulmns of data by this script, the Data should be
#In the Same form as File "Tota_SF_New.csv" (maybe better to remove the first Raw)
#The Methodes Read the Data and Form 3 Arrays based on the 3 Spreading Factors
#then the Latency is calculated by subtracting each stage Timming, then the Average is 
#Been taken to avoide having negative Values. The results is then ploted
#####################################################################
#           Reforming Data to the Correct Form
#####################################################################
import re
from datetime import datetime, time, date

def replace_bad_chars(time_string):
    time_string = re.sub(r'[\"ZT]', '', time_string)
    return time_string.split(":") 


def convert_to_proper_time(time_array, bad_chars=None, cdate=None):
    if bad_chars is None:
        assert len(time_array) == 4
        [hr, min, sec, msec] = time_array
    else:
        #assert len(time_array) == 3
        [hr, mint, secs] = list(replace_bad_chars(time_array))
        sec =  int(secs.split('.')[0])
        try:
            msec =  int(secs.split('.')[1])
        except:
            msec = 0
    if cdate is None:       # if data is in form
        return datetime.combine(date.today(), time(int(hr), int(mint), sec, msec))
    else:
        return datetime.combine(cdate, time(int(hr), int(mint), sec, msec))

def delet_mult_qot(number_string):              # Delet the " " from the Data
    return re.sub('"', '', number_string)





################################################################################
#           Read the Data from the .csv file then categorize it according to SF
################################################################################       

def build_record(data_row):
    [counter, year, month, day, node_hr, node_min, node_sec, node_msec, air_time, gw_time, ttn_time, nr_time, delay, data_rate] = data_row.strip().split(',')      # assign the row
    cdate = date(int(year), int(month), int(day))
    
    return [convert_to_proper_time([int(node_hr), int(node_min), int(node_sec), int(node_msec)], bad_chars=None, cdate=cdate),
            float(delete_mult_quot(air_time))/1000000.0,
            convert_to_proper_time(gw_time, bad_chars=True, cdate=cdate),
            convert_to_proper_time(ttn_time, bad_chars=True, cdate=cdate),
            convert_to_proper_time(nr_time, bad_chars=True, cdate=cdate),
            (float(delete_mult_quot(delay))/1000.0) - 10,
            delete_mult_quot(data_rate)
            ]

data0FLAG = "SF12BW125"
data1FLAG = "SF9BW125"
data2FLAG = "SF7BW125"

data0 = []
data1 = []
data2 = []
#with open("L_poli.csv", 'r') as csvfile:
with open("Test_Latency.csv", 'r') as csvfile:
    data = csvfile.readlines()      # Read a line from the .csv file
    for i in range(1,len(data)):    # ignore the Counter and start read after until SF
        record = build_record(data[i])
        #print(record)
        if record[-1] == data0FLAG:
            data0.append(record)
        elif record[-1] == data1FLAG:
            data1.append(record)
        else:
            data2.append(record)
#####################################################################
#           Test   
#           len(data0) = 98
#           data0[0] =  [datetime.datetime(2020, 9, 27, 17, 28, 25, 843596),
#  2.465792,
#  datetime.datetime(2020, 9, 27, 17, 28, 28, 392),
#  datetime.datetime(2020, 9, 27, 17, 28, 28, 413),
#  datetime.datetime(2020, 9, 27, 17, 28, 28, 488),
#  0.01800049999999942,
#  'SF12BW125']
#####################################################################
           


################################################################################
#           Calculate the Latency ( subtract the timing )
################################################################################ 

def calculate_delays(record):
    node_time, air_time, gw_time, ttn_time, nr_time, ref_delay, _ = record
    time_deltas = [gw_time - node_time, ttn_time - gw_time, nr_time - ttn_time ]
    return  list(map(lambda x: x.total_seconds(), time_deltas))
    

################################################################################
#           Assign the Latency of each SF to an Array , data0 = SF12
################################################################################ 

data0_delays =[]
for record in data0:
    data0_delays.append(calculate_delays(record))

data1_delays =[]
for record in data1:
    data1_delays.append(calculate_delays(record))

data2_delays =[]
for record in data2:
    data2_delays.append(calculate_delays(record))
    

################################################################################
#           Calculate each latency component alone
################################################################################ 


SF12_node_gw_delays = [delay[0] for delay in data0_delays]
SF12_node_gw_delay_average = np.mean(SF12_node_gw_delays)*1000
SF12_node_gw_delay_std = np.std(SF12_node_gw_delays)

SF12_gw_ttn_delays = [delay[1] for delay in data0_delays]
SF12_gw_ttn_delay_average = np.mean(SF12_gw_ttn_delays)*1000
SF12_gw_ttn_delay_std = np.std(SF12_gw_ttn_delays)

SF12_ttn_tnr_delays = [delay[2] for delay in data0_delays]
SF12_ttn_tnr_delay_average = np.mean(SF12_ttn_tnr_delays)*1000
SF12_ttn_tnr_delay_std = np.std(SF12_ttn_tnr_delays)

SF9_node_gw_delays = [delay[0] for delay in data1_delays]
SF9_node_gw_delay_average = np.mean(SF9_node_gw_delays)*1000

SF9_node_gw_delay_std = np.std(SF9_node_gw_delays)

SF9_gw_ttn_delays = [delay[1] for delay in data1_delays]
SF9_gw_ttn_delay_average = np.mean(SF9_gw_ttn_delays)*1000
SF9_gw_ttn_delay_std = np.std(SF9_gw_ttn_delays)

SF9_ttn_tnr_delays = [delay[2] for delay in data1_delays]
SF9_ttn_tnr_delay_average = np.mean(SF9_ttn_tnr_delays)*1000

SF9_ttn_tnr_delay_std = np.std(SF9_ttn_tnr_delays)


SF7_node_gw_delays = [delay[0] for delay in data2_delays]
SF7_node_gw_delay_average = np.mean(SF7_node_gw_delays)*1000

SF7_node_gw_delay_std = np.std(SF7_node_gw_delays)

SF7_gw_ttn_delays = [delay[1] for delay in data2_delays]
SF7_gw_ttn_delay_average = np.mean(SF7_gw_ttn_delays)*1000
SF7_gw_ttn_delay_std = np.std(SF7_gw_ttn_delays)

SF7_ttn_tnr_delays = [delay[2] for delay in data2_delays]
SF7_ttn_tnr_delay_average = np.mean(SF7_ttn_tnr_delays)*1000

SF7_ttn_tnr_delay_std = np.std(SF7_ttn_tnr_delays)


################################################################################
#           Plotting the results
################################################################################ 
import matplotlib.pyplot as plt 
import numpy as np

labels = ['SF12', 'SF9', 'SF7']
node_gw_delay_means = [g1_node_gw_delay_average, g2_node_gw_delay_average, g3_node_gw_delay_average ]
gw_ttn_delay_means = [g1_gw_ttn_delay_average, g2_gw_ttn_delay_average, g3_gw_ttn_delay_average ]
ttn_tnr_delay_means = [g1_ttn_tnr_delay_average, g2_ttn_tnr_delay_average, g3_ttn_tnr_delay_average ]

node_gw_delay_std = [SF12_node_gw_delay_std, SF9_node_gw_delay_std, SF7_node_gw_delay_std]
gw_ttn_delay_std = [SF12_gw_ttn_delay_std, SF9_gw_ttn_delay_std, SF7_gw_ttn_delay_std]
ttn_tnr_delay_std = [SF12_ttn_tnr_delay_std, SF9_ttn_tnr_delay_std, SF7_ttn_tnr_delay_std]

width = 0.35       # the width of the bars: can also be len(x) sequence

fig, ax = plt.subplots()

ax.bar(labels, node_gw_delay_means, width, yerr=node_gw_delay_std, label='TOA')
#ax.semilogy(labels, node_gw_delay_means, width, yerr=node_gw_delay_std, label='TOA')
#ax.bar(labels, gw_ttn_delay_means, width,
                    #yerr=gw_ttn_delay_std,
#                    label='Gw->TTN')
#ax.bar(labels, ttn_tnr_delay_means, width,
                    #yerr=ttn_tnr_delay_std,
 #                   label='TTN->NR')

ax.legend()
ax.set_ylabel('Latency (ms)')
ax.set_title('Latency Vs SF')
ax.legend()

plt.show()
